//-----------------------------------------------------------------------------
// @Ɛ[xl`
//-----------------------------------------------------------------------------

struct VS_OUT_NmlDpt
{
	float4 pos		: POSITION; 		// ˉeϊW
	float2 uv		: TEXCOORD0;
	float3 normal	: TEXCOORD1;		// @
	float3 tangent	: TEXCOORD2;
	float3 binormal	: TEXCOORD3;
	float4 depth	: TEXCOORD4;		// [xl
};



VS_OUT_NmlDpt NormalDepth_VS( 
	float4 pos		: POSITION, 
	float2 uv		: TEXCOORD0, 
	float3 normal	: NORMAL, 
	float4 tangent	: TANGENT
){
	VS_OUT_NmlDpt Out;
	Out.pos = Out.depth = mul( pos, matWVP );
	Out.uv  = uv + offsetUV;
	Out.normal = mul( normal, (float3x3)matWorld );					// @xNg]
	if( useNormalMap ){
		Out.tangent  = mul( tangent.xyz, (float3x3)matWorld );			// ڐxNg]
		Out.binormal = cross( Out.normal, Out.tangent ) * tangent.w;	// ڐƖ@]@߂
	}
	return Out;
}



float4 NormalDepth_PS( VS_OUT_NmlDpt In ) : COLOR
{
	float4 col;
	col.xyz = normalize( In.normal ) * 0.5 + 0.5;

	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );
	col.xyz = Norm * 0.5 + 0.5;
	// ǂl-1~10~1ɕϊ̂ĕ̐^̃eNX`
	// ^̃eNX`ƕLȂ̂-1~1ŗǂ
	// ̏o͂ȂāA|CgCg̎QƂł0~1-1~1ɕϊ鏈邩
	// ̏vZ̖ʂȂ
	// ̏o͂͐xႢƃ|CgCǧʂUXȎɂȂ
	// sAx̍tH[}bgA܂蕂̃tH[}bgɂȂ炴𓾂Ȃ̂
	// lƕϊvȂɂׂȂ

	col.w = In.depth.z / In.depth.w;
	return col;
}



technique NormalAndDepth
{
	pass P0
	{
		VertexShader = compile vs_2_0 NormalDepth_VS();
		PixelShader = compile ps_2_0 NormalDepth_PS();
		CullMode = faceRight;
		AlphaBlendEnable = False;
	}
}


