//-----------------------------------------------------------------------------
// {[EFCg
//-----------------------------------------------------------------------------

float selectedBone = -1;

struct VS_IN_VisWeight{
	float4	Pos		: POSITION;
	float4	Weight	: BLENDWEIGHT;
	float4	Indices	: BLENDINDICES;
};

struct VS_OUT_VisWeight{
	float4	Pos		: POSITION;
	float4	Color	: COLOR0;
};



VS_OUT_VisWeight VisWeight_VS( VS_IN_VisWeight In )
{
	VS_OUT_VisWeight Out;
	Out.Pos		= mul( In.Pos, matWVP );
	Out.Color	= float4( 0.8, 0.8, 0.8, 1.0 );
	float Weight[4] = (float[4])In.Weight;		// _EFCgS󂯎
	for( int i=0; i < 4; ++i ){
		if( Weight[i] <= 0.0 ) continue;
		if( In.Indices[i] == selectedBone ){
			if( Weight[i] <= 0.5 ){
				Out.Color  = 2 * (0.5 - Weight[i]) * float4( 1.0, 1.0, 0.0, 1.0 );
				Out.Color += 2 *        Weight[i]  * float4( 1.0, 0.0, 0.0, 1.0 );
			}else{
				Out.Color  = 2 * (0.5 - (Weight[i]-0.5)) * float4( 1.0, 0.0, 0.0, 1.0 );
				Out.Color += 2 * (       Weight[i]-0.5 ) * float4( 0.0, 0.0, 1.0, 1.0 );
			}
			break;
		}
	}
	return Out;
}

float4 VisWeight_PS( VS_OUT_VisWeight In ) : COLOR0
{
	float4 col = In.Color;
	return col;
}



technique VisWeight
{
	pass P0
	{
		VertexShader = compile vs_2_0 VisWeight_VS();
		PixelShader = compile ps_3_0 VisWeight_PS();
		CullMode = faceRight;
	}
}


